section \<open>Exercises for Session 10\<close>

theory Exercises10
  imports Demo10
begin

subsection \<open>Exercise 1\<close>

text \<open>
Given the data type
\<close>
datatype 'a btree = Empty | Node 'a "'a btree" "'a btree"
text \<open>
Define notation that allows you to write for example

  \<open><1,<<3>,2>>\<close>

instead of

  \<open>Node 1 Empty (Node 2 (Node 3 Empty Empty) Empty)\<close>

\<close>


subsection \<open>Exercise 2\<close>

text \<open>
Write a @{class to_string} instance for @{typ nat}.
\<close>


subsection \<open>Exercise 3\<close>

text \<open>
Given the inductive definition of \<open>LT_nat\<close> below, prove that it coincides with
@{term "(\<^bold><) :: nat \<Rightarrow> nat \<Rightarrow> bool"}.
\<close>
inductive LT_nat :: "nat \<Rightarrow> nat \<Rightarrow> bool"
  where
    [simp]: "LT_nat 0 (Suc y)"
  | "LT_nat x y \<Longrightarrow> LT_nat (Suc x) (Suc y)"


end
